typedef struct ccelsexp
   { char tag;
     union 
       { char *atom;
         struct scellista *lis;
       } valor;
    } celsexp,  *apsexp;

typedef struct scellista 
   { apsexp elemento;
     struct scellista *seg;} cellista,  *aplista;

#define tipo(s) (s->tag)                   /*:apsexp*/
#define ATOMO 'a'
#define ATCONST 'c'
#define LISTA 'l'
#define isatomo(s) (tipo(s) == ATOMO)      /*:apsexp*/
#define isatconst(s) (tipo(s) == ATCONST)  /*:apsexp*/
#define atomo(s) (s->valor).atom           /*:apsexp*/
#define lista(s) (s->valor).lis            /*:apsexp*/
#define head(l) (l->elemento)              /*:aplista*/
#define tail(l) (l->seg)                   /*:aplista*/
#define el1(l) (l->elemento)               /*:aplista*/
#define el2(l) (l->seg->elemento)          /*:aplista*/
#define nill ((aplista)NULL)
#define snill ((apsexp)NULL)
#define lista1(a1) cons(a1,nill)
#define lista2(a1,a2) cons(a1,cons(a2,nill))
#define lista3(a1,a2,a3) cons(a1,lista2(a2,a3))
#define lista4(a1,a2,a3,a4) cons(a1,lista3(a2,a3,a4))

apsexp mkatomo();
apsexp mkatconst();
apsexp mklista();
aplista cons();
aplista conc();
aplista inverte(aplista original);
apsexp fununa();
apsexp funbin();
apsexp funtre();
apsexp funnar();
apsexp deffun();
apsexp mkpair();
apsexp mkter();
void travessia();
